#ifndef DLLIST_HPP
#define DLLIST_HPP

template <typename T>
struct DLList {
  DLList<T>* left;
  DLList<T>* right;

  T* data_ptr;

  unsigned int* count_ptr;
  bool initialized = false;

  DLList<T>* remove();
  void replace();
  DLList<T>* addNewLeft(T* val);
  DLList<T>* addNewRight(T* val);
  void initialize();
  void destroy();
};

template <typename T>
DLList<T>* DLList<T>::remove() {
  if (*count_ptr == 1) {
    *count_ptr = *count_ptr - 1;
    return this;
  } else if (*count_ptr == 0) {
    return this;
  }
  left->right = right;
  right->left = left;
  (*count_ptr)--;

  return right;
}

template <typename T>
void DLList<T>::replace() {
  if (*count_ptr > 0) {
    left->right = this;
    right->left = this;
    (*count_ptr)++;
  } else {
    (*count_ptr)++;
  }
}

template <typename T>
DLList<T>* DLList<T>::addNewLeft(T *val) {
  DLList<T>* nNode = new DLList<T>();
  nNode->data = val;
  nNode->count_ptr = count_ptr;

  (*nNode->count_ptr)++;

  nNode->left = left;
  left->right = nNode;
  nNode->right = this;

  left = nNode;
  return nNode;
}

template <typename T>
DLList<T>* DLList<T>::addNewRight(T *val) {
  DLList<T>* nNode = new DLList<T>();
  nNode->data = val;
  nNode->count_ptr = count_ptr;

  (*nNode->count_ptr)++;

  nNode->right = right;
  right->left = nNode;
  nNode->left = this;

  right = nNode;
  return nNode;
}

template <typename T>
void DLList<T>::initialize() {
  left = this;
  right = this;
  count_ptr = new int(1);
}

template <typename T>
void DLList<T>::destroy() {
  if (initialized) {
    delete count_ptr;
  }

  DLList<T>* current = right;
  while (current != this) {
    current = current->right;
    delete current->left;
  }

  delete this;
}

#endif
