#ifndef INTEGER_HPP
#define  INTEGER_HPP

#include <array>

static_assert(sizeof(uint_fast64_t) >= 8, "uint_fast64_t is of an inconsistent size.");

template <unsigned int T>
struct uint_mod {
  unsigned int val;

  uint_mod(unsigned int input) {
    val = input % T;
  }

  void operator=(unsigned int i) {
    val = i % T;
  }

  friend uint_mod<T> operator+(uint_mod<T> lhs, const unsigned int& rhs) {
    lhs = lhs.val + rhs;
    return lhs;
  }

  explicit operator unsigned int() const {
    return val;
  }
};

unsigned int popCount(uint_fast64_t a);

#endif // INTEGER_HPP
