#ifndef LOGGER_HPP
#define LOGGER_HPP

#include <string>
#include <iostream>

template <typename T>
void logger(
  T message
) {
  std::cerr << "==  L " << message << "\n";
}

template <typename T>
void cLogger(
  T message, bool cond
) {
  if (cond)
    std::cerr << "== CL " << message << "\n";
}


#ifdef MESSAGELOG

#define LOG(MESSAGE) logger(MESSAGE)
#define CLOG(MESSAGE, BOOL) cLogger(MESSAGE, BOOL)

#else

#define LOG(MESSAGE) {}
#define CLOG(MESSAGE, BOOL) {}

#endif // MESSAGELOG

#endif  // LOGGER_HPP
