#include "square.hpp"

std::ostream& operator << (std::ostream& stream, const Square& square) {
  for (std::array<unsigned int, N> row : square) {
    stream << util::join<unsigned int, N>(row, " ") << "\n";
  }

  return stream;
}

std::ostream& operator << (std::ostream& stream, const std::vector<Square>& squares) {
  for (Square square : squares) {
    stream << square;
  }

  return stream;
}

std::vector<Square> parseSquares(std::istream& stream) {
  std::string line;
  std::getline(stream, line);
  std::stringstream ss(line);
  unsigned int n;
  ss >> n;

  std::vector<Square> squares(n);
  for (unsigned int square = 0; square < n; square++) {

    for (unsigned int row = 0; row < N; row++) {
      std::getline(stream, line);
      ss = std::stringstream(line);

      for (unsigned int col = 0; col < N; col++) {
        ss >> squares[square][row][col];
      }
    }
  }

  return squares;
}

void swapSquares(std::vector<Square>& squares, unsigned int i, unsigned int j) {
  Square temp = squares[i];
  squares[i] = squares[j];
  squares[j] = temp;
}
