// AUTHOR: Michael Gill
// School or Mathematics
// Monash University
// Clayton, Victoria, AU 3800
// email:  Michael.Gill@Monash.edu
//
// A set of program wide definitions and typename declarations. All header files
// should include this file to be ensure project consistency.
// Copyright (C) 2019  Michael Gill
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef LATIN10_TEMPLATE_GENERATOR_HPP_
#define LATIN10_TEMPLATE_GENERATOR_HPP_

#include <iostream>
#include <vector>
#include <array>
#include <set>
#include <unordered_set>
#include <string>

#include "template/template.hpp"
#include "template/row.hpp"
#include "symmetry/graph.hpp"

void generateTemplate(
  const std::vector<TRow>& rowsR,
  const std::vector<TRow>& rowsN,
  const std::vector<size_t>& gSizes,
  const std::array<size_t, GDD_B_SIZES>& bSizes,
  const size_t& rowRelation,
  const size_t& colRelation
);

#endif
