// AUTHOR: Michael Gill
// School or Mathematics
// Monash University
// Clayton, Victoria, AU 3800
// email:  Michael.Gill@Monash.edu
//
// A set of utilities for dealing with small trivial thing.
// Copyright (C) 2019  Michael Gill
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef LATIN10_UTIL_LIST_HPP_
#define LATIN10_UTIL_LIST_HPP_

#include <string>
#include <sstream>

// Formats a string by iterating from start to finish demarkated by a delim.
template <typename ForwardIt>
std::string join(ForwardIt start, ForwardIt finish, std::string delim=" ") {
  std::stringstream ss;
  if (start == finish) return "";

  while (start+1 != finish) {
    ss << (*start) << delim;
    start++;
  }
  ss << (*start);

  return ss.str();
}

#endif // LATIN10_UTIL_LIST_HPP_
